(function(window, document, $, undefined){

  var hollerpro = {};

  hollerpro.init = function() {
    hollerpro.listeners();
  }

  // Event listeners
  hollerpro.listeners = function() {

    $('body')
    .on('click', '.hwp-expand-side', hollerpro.fullSide )
    .on('click', '.hwp-expanded-side .hwp-close i', hollerpro.fullSide )
    .on('click', '.holler-show', hollerpro.forceShow )
    .on('click', '.holler-box .gform_wrapper input[type=submit]', hollerpro.gfSubmit )

  }

  // Open and close full side view
  hollerpro.fullSide = function(e) {

    // prevents firing twice
    e.preventDefault();

    var banner = $('.holler-banner');
    var height;

    if( banner.length && banner.hasClass('hwp-show') ) {
    	height = banner.outerHeight();
    }

    var id = $(e.target).closest('.holler-box').attr('id');

    var item = $( '#' + id );

    item.css('margin-top', height );
    
    item.toggleClass('hwp-expanded-side');

    item.toggleClass('hwp-minimizing', !item.hasClass('hwp-expanded-side') );
    setTimeout( function() {
      item.removeClass('hwp-minimizing');

      // conversion is not triggered automatically, have to do it here
      var num = id.split('-')[1];
      
      if( item.hasClass( 'hwp-expanded-side' ))
        window.hollerbox.conversion( num );

    }, 1000);

    return false;

  }

  // force show a hidden box, used for link activation
  hollerpro.forceShow = function( e ) {

  	var id = $(e.target).data('id');

  	if( !id )
  		return;

    e.preventDefault();

    // clear any hide cookies so it always shows when link is clicked
    window.hollerbox.setCookie( 'hwp-' + id + '_hide', '', -1 );

  	window.hollerbox.doChecks( id, true );

  }

  // when GF submit button is clicked, count a conversion
  hollerpro.gfSubmit = function(e) {
    var id = $(e.target).closest('.holler-box').attr('id');
    var num = id.split('-')[1];
    window.hollerbox.conversion( num );
  }

  $(window).load(function(){
    hollerpro.init();
  })

  window.hollerpro = hollerpro;

})(window, document, jQuery);